#include <stdio.h>
#include "pvm3.h"

#define PROC 10
#define NELEM 1000

main()
{
  int mytid ;                /* my task id */
  int tids[ PROC ] ;         /* task ids */
  int n ;                    /* number of data elements */
  int me ;                   /* integer id of my task */
  int i, msgtype ;
  int nproc ;                /* number of processes */
  int master ;               /* integer id of master program */
  int data[100] ;          /* data array */
  int result ;               /* my partial sum */
  int num,kalan ;                  /* my partial max */



  /* Enroll In PVM */
  mytid = pvm_mytid() ;

  /* Receive Data From Master */
  msgtype = 0 ;
  pvm_recv( -1, 1) ;
  pvm_upkint( data, 100, 1 ) ;
  pvm_upkint( tids, 10, 1 ) ;

  /* Determine Which Slave I Am (0 -- nproc-1) */
  for ( i = 0 ; i < nproc; i++ )
    if ( mytid == tids[ i ] ) 
    { 
      me = i ; 
      break ; 
    }

  /* Add My Portion Of The Data */
  for(i=0;i<100;++i)
  {
    printf("\nDatalari isliyorum.");
    num = data[i];
    kalan = num % 10;
    num = num / 10 ;
    while (num != 0)
    {
      while (num != 0)
      {
        kalan = (num % 10) + kalan;
        num = num / 10 ;
      }
      num = kalan ;
      kalan = num % 10 ;
      num = num / 10 ;
    }
    data[i] = kalan;
  }
  printf("\nDatalari Mastera yolla.");
  /* Send Result To The Master */
  pvm_initsend(PvmDataDefault);
  pvm_pkint(&me, 1, 1);
  pvm_pkint(data, 100, 1);
  msgtype = 5;
  master = pvm_parent();
  pvm_send(master, msgtype);

  /* Program Finished.  Exit PVM */
  pvm_exit();

  return(0);
}

