#include <stdio.h>
#include <string.h>
#include <pvm3.h>

#define SLAVENAME "crypts"
#define PROC 10

main ()
{
	int mytid;                   /* my task id */
	int tids[PROC];              /* slave task ids */
	int nproc = PROC;            /* number of processes */
	int numt, i, x, x1;

	FILE		*fp;
	char		str[256], str1[256];
	
  /* Enroll In PVM */
  mytid = pvm_mytid();

  /* Start Slave Tasks */
  numt = pvm_spawn(SLAVENAME, (char**)0, 0, "", nproc, tids);
  if (numt < nproc)
    {
    printf("Trouble spawning slaves. Aborting. Error codes are: \n");
    for (i=numt; i<nproc; i++)
      printf("TID %d %d\n", i, tids[i]);
    for (i=0; i<numt; i++)
      pvm_kill(tids[i]);
    pvm_exit();
    exit(1);
    }

  /* Open Input File and Initialize Data */
  if ((fp = fopen("crypt.txt","r")) == NULL)
    {
    printf("Can't open the input file\n");
    exit(1);
    }
  for(i=0;i<nproc;i++)
  {
  	fgets(str, 256, fp);
	str[strlen(str)-1]='\0';
	pvm_initsend(PvmDataDefault);
	pvm_pkstr(str);
	pvm_send(tids[i], 1);  
  }
	strcpy(str1,"");
	x1=0;
	for(i=0; i < nproc; i++)  
	{
		pvm_recv(tids[i], 2);
		pvm_upkstr(str);
		pvm_upkint(&x, 1, 1); 
		printf("x=%d str=%s\n",x,str);
		if (x==1)
		{
			printf("In page %d has found %s\n", i, str); 
			strcpy(str,"");
		}
		else
		if ((x1==3) && (x==2))
			if (strcmp(strcat(str1,str),"cryptosporidium")==0)
			     printf("In pages %d-%d has found %s\n", i-1,i, "cryptosporidium"); 
		x1=x;
		strcpy(str1,str);

	}

  /* Program Finished. Exit PVM */
  pvm_exit();
  return(0);

}

