#include <stdio.h>
#include <stdlib.h>
#include <pvm3.h>
#include <time.h>
 
#define SLAVENAME "primenum1s"
#define PROC 1
 
main()
  {
  int mytid ;                  /* my task id */
  int tids[ 1 ];
  int nproc = PROC ;           /* number of processes */
  int numt, i, j, who, msgtype ;
  int data,dataouter ;                   /* the partial results of fact.*/
  int n ; /* the last number that will be multiplied */
  float partialmult = 1; /* partial mult at server side */
  float partialmults ; /* partial mult at client side */
  int partialn ; /* the half of the given number */
  time_t t1,t2;
  struct timeval tv1, tv2;        /* for timing */
  
  printf("\nEnter the number => ");
  scanf("%d",&n);
  
  /* Enroll In PVM */
  mytid = pvm_mytid() ;
  
  /* Start Slave Tasks */
  numt = pvm_spawn( SLAVENAME, (char**)0, 0, "", nproc, tids ) ;
  if ( numt < nproc )
    { 
      printf( "Trouble spawning slaves. Aborting. Error codes are: \n" ) ;
      for ( i=numt ; i<nproc ; i++ )
        printf( "TID %d %d\n", i, tids[ i ] ) ;
      for ( i = 0 ; i < numt ; i++ )
        pvm_kill( tids[ i ] ) ;
      pvm_exit() ;
      exit( 1 ) ;
    }
  gettimeofday(&tv1, (struct timezone*)0);
  time(&t1);
  /*Second Algorithm Implementation */
  gettimeofday(&tv1, (struct timezone*)0);
  pvm_initsend(PvmDataDefault);
  pvm_pkint(&n, 1, 1);
  pvm_send(tids[0],1);
  for( i=1; i < n + 1 ; ++i )
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(&i, 1, 1);
    pvm_send(tids[0],1);
  }
  pvm_initsend(PvmDataDefault);
  pvm_pkint(&i, 1, 1);
  pvm_send(tids[0],1);
  msgtype = 5 ;
  pvm_recv(-1, msgtype);
  pvm_upkfloat(&partialmults, 1, 1);
 
  printf("\nThe factorial of %d is = %lf\n", n, partialmults );
  gettimeofday(&tv2, (struct timezone*)0);
  printf("The time spend for this algorithm is =%8d uSec\n", (tv2.tv_sec -
tv1.tv_sec) * 1000000 + tv2.tv_usec - tv1.tv_usec);
  
/* Program Finished. Exit PVM */
  pvm_exit() ; 
  return( 0 ) ;
  }

