/*Slave task of Student Grades Problem*/
#include<stdio.h>
#include<stdlib.h>
#include<pvm3.h>

#define PROC 3
#define Students 100
#define Grades 100

void main()
{
	int mytid;
	int tids[PROC];
	int i,j,me,msgtype,number;
	int nproc,master;
	int ArrayOfGrades[Students][Grades];
	float Average[(Students/(PROC+1))];
        float sum;

	mytid = pvm_mytid();
	sum = 0;

	/*Receive Data from Master*/
	msgtype = 0;
	pvm_recv(-1,msgtype);
	pvm_upkint(&nproc,1,1);
	pvm_upkint(tids,nproc,1);
	pvm_upkint(ArrayOfGrades,(Students*Grades),1);

	/*Determine Mytid*/
	for(i=0;i<nproc;i++)
		if (mytid == tids[i])
		{
			me=i;
			break;
		}

	/*Calculating my Data*/
	for(i=me*(Students/(PROC+1));i<(me+1)*(Students/(PROC+1));i++)
	{
		for(j=0;j<Grades;j++)
			sum += (ArrayOfGrades[i][j]*ArrayOfGrades[i][j]);
		Average[i-(me*(Students/(PROC+1)))] = sum / Grades;
		sum = 0;
	}

	/*Send Result to Master*/
	pvm_initsend(PvmDataDefault);
	pvm_pkint(&me,1,1);
	pvm_pkfloat(Average,1,1);
	msgtype = 5;
	master = pvm_parent();
	pvm_send(master,msgtype);

	/*Exit PVM*/
	pvm_exit();
}
