#include <stdio.h>
#include <stdlib.h>
#include <pvm3.h>
 
#define SLAVENAME "radixs"
#define PROC 4
#define NELEM 16
 
main()
  {
  int mytid ;                  /* my task id */
  int tids[ PROC ] ;           /* slave task ids */
  int n = NELEM ;              /* number of data elements */
  int nproc = PROC ;           /* number of processes */
  int numt, i, j, who, msgtype,you ;
  int data[ 16 ] ;            /* data array */
  char fn[ 255 ] ;             /* array used for path name */
  FILE *fp;                    /* pointer to the input file */
 
  /* Enroll In PVM */
  mytid = pvm_mytid() ;
 
  /* Start Slave Tasks */
  numt = pvm_spawn( SLAVENAME, (char**)0, 0, "", nproc, tids ) ;
  if ( numt < nproc )
    {
      printf( "Trouble spawning slaves. Aborting. Error codes are: \n" ) ;
      for ( i=numt ; i<nproc ; i++ )
        printf( "TID %d %d\n", i, tids[ i ] ) ;
      for ( i = 0 ; i < numt ; i++ )
        pvm_kill( tids[ i ] ) ;
      pvm_exit() ;
      exit( 1 ) ;
    }
 
  /* Get Proper Path For Input File */
  strcpy( fn, getenv( "HOME" ) ) ;
  strcat( fn, "/pvm3/bin/SUN4SOL2/data.txt" ) ;
  /* Open Input File and Initialize Data */
  if ( ( fp = fopen( fn, "r" ) ) == NULL )
    {
      printf("Can't open the input file: %s\n\n", fn);
      exit(1);
    }
  for ( j=0; j < 16; j++ )
  {    
    fscanf( fp, "%d", &data[ j ] ) ;
  }
  you = 0 ;
  pvm_initsend(PvmDataDefault);
  pvm_pkint(data, 16, 1);
  pvm_pkint(tids, 4, 1);
  pvm_pkint(&you,1,1);
  pvm_send(tids[0],1);

  fclose(fp);
  printf("Datalar yollandi sonuc bekleniyor\n");
  for(j=0;j<16;++j)
  {
    printf("%d ",data[j]);
  }
/* Wait For Results From The Slaves */
  msgtype = 5 ;

  pvm_recv(-1, msgtype);
  pvm_upkint(data, 16, 1);
  for(j=0;j<16;++j)
  {
    printf("%d ",data[j]);
  }

  printf ( "The operation has been finished\n") ;
      
  /* Program Finished. Exit PVM */
  pvm_exit() ;
  return( 0 ) ;
  }
        

