#include <stdio.h>
#include "pvm3.h"

#define PROC 4
#define NELEM 16

int data[16] ;          /* data array */
int nine[16] ;
int eigth[16] ;
int seven[16] ;
int six[16] ;
int five[16] ;
int four[16] ;
int three[16] ;
int two[16] ;
int one[16] ;
int zero[16] ;
int j ;
int modfac, divfac ;
int temp;

void putinappplace(int temp, int num)
{
  if (temp == 0)
  {
    for(j = 0;(zero[j] != 0); ++j);
    zero[j] = num ;
  }
  if (temp == 1)    
  { 
    for(j = 0;(one[j] != 0); ++j);
    one[j] = num ;
  }    
  if (temp == 2)    
  { 
    for(j = 0;(two[j] != 0); ++j);
    two[j] = num ;
  }    
  if (temp == 3)    
  { 
    for(j = 0;(three[j] != 0); ++j);
    three[j] = num ;
  }    
  if (temp == 4)    
  { 
    for(j = 0;(four[j] != 0); ++j);
    four[j] = num ;
  }    
  if (temp == 5)    
  { 
    for(j = 0;(five[j] != 0); ++j);
    five[j] = num ;
  }    
  if (temp == 6)    
  { 
    for(j = 0;(six[j] != 0); ++j);
    six[j] = num ;
  }    
  if (temp == 7)    
  { 
    for(j = 0;(seven[j] != 0); ++j);
    seven[j] = num ;
  }    
  if (temp == 8)    
  { 
    for(j = 0;(eigth[j] != 0); ++j);
    eigth[j] = num ;
  }    
  if (temp == 9)    
  { 
    for(j = 0;(nine[j] != 0); ++j);
    nine[j] = num ;
  }    

}

main()
{
  int mytid ;                /* my task id */
  int tids[ PROC ];
  int n ;                    /* number of data elements */
  int me ;                   /* integer id of my task */
  int i, msgtype ;
  int nproc ;                /* number of processes */
  int master ;               /* integer id of master program */
  int result ;               /* my partial sum */
  int num,kalan ;                  /* my partial max */
  int fac ;
  /* Enroll In PVM */
  mytid = pvm_mytid() ;
  master = pvm_parent();
  for(i=0;i<16;++i)
  {
    zero[i] = 0 ;
    one[i] = 0 ;
    two[i] = 0 ;
    three[i] = 0;
    four[i] = 0;
    five[i] = 0;
    six[i] = 0;
    seven[i] = 0;
    eigth[i] = 0;
    nine[i] = 0 ;
  }
  /* Receive Data From Master */
  msgtype = 0 ;
  pvm_recv( -1, 1) ;
  pvm_upkint( data, 16, 1 ) ;
  pvm_upkint( tids, 4, 1 ) ;
  pvm_upkint(&me, 1, 1);
  /* Determine Which Slave I Am (0 -- nproc-1) */
  /*for ( i = 0 ; i < nproc; i++ )
    if ( mytid == tids[ i ] )
    {
      me = i ;
      break ;  
    }*/
 
  /* Add My Portion Of The Data */
  if (me == 0)
  {
    modfac = 10 ;
    divfac = 1;
    for (i=0; i < 16; ++i)
    {
      temp = data[i] % modfac ;
      temp = temp / divfac ;
      putinappplace( temp, data[i] );
    }
  }
  if (me == 1)
  {
    modfac = 100 ;
    divfac = 10;
    for (i=0; i < 16; ++i)
    {
      temp = data[i] % modfac ;
      temp = temp / divfac ;
      putinappplace( temp, data[i] );
    }  
  }    
  if (me == 2)
  {
    modfac = 1000 ;
    divfac = 100;
    for (i=0; i < 16; ++i)
    {
      temp = data[i] % modfac ;
      temp = temp / divfac ;
      putinappplace( temp, data[i] );
    }  
  }    
  if (me == 3)
  {
    modfac = 10000 ;
    divfac = 1000;
    for (i=0; i < 16; ++i)
    {
      temp = data[i] % modfac ;
      temp = temp / divfac ;
      putinappplace( temp, data[i] );
    }  
  }    
  i = 0 ;
  for(j=0;zero[j] != 0; ++j)
  {
    data[i] = zero[j];
    ++i;
  }
  for(j=0;one[j] != 0; ++j) 
  {
    data[i] = one[j];
    ++i;
  }
  for(j=0;two[j] != 0; ++j) 
  {
    data[i] = two[j];
    ++i;
  }
  for(j=0;three[j] != 0; ++j) 
  {
    data[i] = three[j];
    ++i;
  }
  for(j=0;four[j] != 0; ++j) 
  {
    data[i] = four[j];
    ++i;
  }
  for(j=0;five[j] != 0; ++j) 
  {
    data[i] = five[j];
    ++i;
  }
  for(j=0;six[j] != 0; ++j) 
  {
    data[i] = six[j];
    ++i;
  }
  for(j=0;seven[j] != 0; ++j) 
  {
    data[i] = seven[j];
    ++i;
  }
  for(j=0;eigth[j] != 0; ++j) 
  {
    data[i] = eigth[j];
    ++i;
  }
  for(j=0;nine[j] != 0; ++j) 
  {
    data[i] = nine[j];
    ++i;
  }

  printf("\nDatalari Mastera yolla.");
  /* Send Result To The Master */  

/*  if (me != 0 )
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 16, 1);
    pvm_pkint(tids, 4, 1);
    pvm_send(tids[me - 1],1);
  }*/
  me = me + 1 ;
  if (me == 1)
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 16, 1);
    pvm_pkint(tids, 4, 1);
    pvm_pkint(&me, 1, 1);
    pvm_send(tids[me],1);

  }
  if (me == 2)
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 16, 1);
    pvm_pkint(tids, 4, 1);
    pvm_pkint(&me, 1, 1);  
    pvm_send(tids[me],1);  
    
  }  
  if (me == 3)
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 16, 1);
    pvm_pkint(tids, 4, 1);
    pvm_pkint(&me, 1, 1);  
    pvm_send(tids[me],1);  
    
  }  

  if (me == 4 )
  {
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 16, 1);  
    msgtype = 5;
    pvm_send(master, msgtype);
  }
  /* Program Finished.  Exit PVM */
  pvm_exit();
  return(0);
}

